{------------------------------------------------------------------------------}
(*
   Unit Name: PvmTestiForm
   Purpose  : To show different ways to call function
   Author   : Vesa Lappalainen
   Date     : 26.11.2000
   Changed  : 5.8.2004 / Miika Nurminen
                - listty Visual C++ -DLL
                   Huom. VC++:n funktioiden nimet saa selville
                   IMPDEF-komentoriviohjelmalla

   Testit     :
                                                           vakiot
                                                                   DCUSATTTINEN
                                                            NORMAALIKUTSU

   1) Staattinen linkitys, osoitteeta selvitetn
      linkitysaikana
    a) aliohjelma delphi DCU:ssa                                 x          x
    b) aliohjelma objektitiedostossa                             x          -
          extrenal; {$l ...obj}-rivi
   2) Dynaaminen linkitys, aliohjelman osoite selvitetn
      ohjelman latauksen aikana, aliohjelma .dll-tiedostossa     x          -
          extrenal '....dll'-rivi

   3) Totaalisen dynaaminen linkitys, .dll ladataan ajonaikana,  -          o
      samoin selvitetn mys funktion osoitteet ajon aikana
*)
{------------------------------------------------------------------------------}

unit PvmTestiForm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Vuosi: TEdit;
    kv: TLabel;
    procedure VuosiChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
 // kommentoi molemmat, jos kytetn dynaamista dll:n latausta
{$define NORMAALIKUTSU}
{!$define DCUSTAATTINEN}
{$ifdef NORMAALIKUTSU}

 {$ifdef DCUSTAATTINEN}

uses kv; // Jos kytetn "normaalisti" delphifunktiota

 {$else} // dynaaminen tai ulkoinen .obj.

function karkausvuosi(vuosi:integer):integer; stdcall;
           // Jos kytetn dll-kirjastoa
//external '..\vcdll\release\vcdll.dll' name '_karkausvuosi@4'; // visual c++ -dll
                            // huom. 'mangled' name
//external 'pvmdll.dll';          // Sama dll-Delphill tehtyn
//external '..\bcbtest\bcbpvm.dll';          // Sama dll-C++builderilla tehtyn
external; {$L ..\pvmdll.obj}     // Jos halutaan kytt suoraan objektia
{$endif}  // DCU-staattisen else, eli dynaaminen tai ulkoinen .obj.


procedure TForm1.VuosiChange(Sender: TObject);
var v:integer;
begin
  v := StrToIntDef(vuosi.text,0);
  if ( karkausvuosi(v) = 1 ) then
    kv.caption := 'On karkausvuosi'
  else
    kv.caption := 'Ei ole karkausvuosi'

end;

{$else} // Totaalisen dynaaminen linkitys

type TBooleanIntFunction = function(i:integer):integer; stdcall;

var karkausvuosi : TBooleanIntFunction;

function FindFunction() : boolean;
var HLibrary : HMODULE;
begin
  Result := true;
  if ( Assigned(karkausvuosi) ) then exit;
  Result := false;
//  HLibrary := LoadLibrary('.\pvmdll.dll');
  HLibrary := LoadLibrary('..\vcdll\release\vcdll.dll');
  if ( HLibrary = 0 ) then exit;
  karkausvuosi := GetProcAddress(HLibrary,'_karkausvuosi@4');
//  karkausvuosi := GetProcAddress(HLibrary,'karkausvuosi');

  Result := Assigned(karkausvuosi);
end;

procedure TForm1.VuosiChange(Sender: TObject);
var v:integer;
begin
  v := StrToIntDef(vuosi.text,0);
  if not FindFunction() then exit;

  if ( karkausvuosi(v) = 1 ) then
    kv.caption := 'On karkausvuosi'
  else
    kv.caption := 'Ei ole karkausvuosi'

end;
{$endif}

end.







