/**************/
/* strdll.c   */
/****************************************************************************
    LIBRARY: STRDLL.C
    PURPOSE: Malli DLL-kirjastosta (Dynamic Linking Library)
    Editor:  Vesa Lappalainen  10.11.1992
    USAGE:
      1) Listn omaan ohjelmaan
           #include "strlib.h"
      2) Kutsut aliohjelmiin:
           KysyJono(...)
      3) Listn omaan .DEF -tiedostoon

           IMPORTS STRDLL.KysyJono
         tai
           listn projektiin .LIB, johon tarvittavat .DLLt on listty
      4) Varmistetaan, ett ajonaikana STRDLL.DLL on joko oletushakemistossa
         tai polussa. 


      PS.  Tm tiedosto toimii sellaisenaan mink tahansa DLL:n
           "pohjelmana".

*****************************************************************************
Tmn kirjaston kntmiseksi pit projektissa olla
  STRDLL.C
  STRLIB.C
  STRDLL.DEF
  STRLIB.RC

ja pit mritell vakio __DLL__ (joka mrittyy automaattisesti kun
laitetaan kntymn DLL:n (ks. alla)

Lisksi tarvitaan STRDLL.H  ja STRLIB.H

-----------------------------------------------------------------------------
DLL-kirjaston erot tavalliseen ohjelmaan:
=========================================

DLL-kirjaston tekemiseksi pit muistaa knt se ensinnkin DLL:ksi
(Borland C++: Options-Application-Windows DLL)

DLL:n .DEF-tiedostossa ei ole NAME, vaan LIBRARY (STRDLL.DEF):

  LIBRARY       STRDLL        ; application's module name
  DESCRIPTION  'Kysyy merkkijonon'
  EXETYPE       WINDOWS       ; required for all Windows applications
  PROTMODE
  CODE  PRELOAD MOVEABLE DISCARDABLE
  DATA  PRELOAD MOVEABLE SINGLE ; HUOM! SINGLE
  HEAPSIZE     1024

"Pohjelmana" on WinLib, ei WinMain
"Lopetusohjelmana" on WEP

"Globaalien" muuttujien kanssa on oltava tarkkana ja kyttmuuttujista
on tehtv oma versio jokaiselle kynniss olevalle kutsulle!

Muuten DLL tehdn kuin mik tahansa ohjelma.

Jos DLL-halutaan list kirjastoon (.LIB), kytet vaikkapa ohjelmaa ImpLib.

****************************************************************************/
#include <windows.h>            /* Tarvitaan kaikissa Windows C-ohjelmissa */

HINSTANCE DLLG_hInstance;

/***************************************************************************/
int CALLBACK _export WEP(int nParam)
{
#pragma argsused
  return 1;
}

/***************************************************************************/
int FAR PASCAL LibMain(HANDLE hInstance, WORD wDataSeg, WORD wHeapSize,
                   LPSTR lpCmdLine)
{
#pragma argsused
  DLLG_hInstance = hInstance;
  if ( wHeapSize > 0 ) UnlockData(0);
  return 1;
}